VERSION 5.00
Begin VB.Form CryptFileDemoForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "CryptFile Demo"
   ClientHeight    =   6255
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8295
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "CryptFileDemoForm.frx":0000
   LinkTopic       =   "CryptFileDemoForm"
   MaxButton       =   0   'False
   ScaleHeight     =   6255
   ScaleWidth      =   8295
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdEncryptBinary 
      Caption         =   "Encrypt Binary"
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   5640
      Width           =   1755
   End
   Begin VB.CommandButton cmdDecryptBinary 
      Caption         =   "Decrypt Binary"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2160
      TabIndex        =   3
      Top             =   5640
      Width           =   1755
   End
   Begin VB.CommandButton cmdDecryptText 
      Caption         =   "Decrypt Text"
      Enabled         =   0   'False
      Height          =   495
      Left            =   6300
      TabIndex        =   5
      Top             =   5640
      Width           =   1755
   End
   Begin VB.CommandButton cmdEncryptText 
      Caption         =   "Encrypt Text"
      Height          =   495
      Left            =   4380
      TabIndex        =   4
      Top             =   5640
      Width           =   1755
   End
   Begin VB.TextBox txtContent 
      Height          =   4215
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "CryptFileDemoForm.frx":1002
      Top             =   1320
      Width           =   7815
   End
   Begin VB.TextBox txtPassphrase 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "This has been willed where willed it must be!"
      Top             =   480
      Width           =   7815
   End
   Begin VB.Label Label2 
      Caption         =   "Content:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   960
      Width           =   7815
   End
   Begin VB.Label Label1 
      Caption         =   "Passphrase:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   120
      Width           =   7815
   End
End
Attribute VB_Name = "CryptFileDemoForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'Demonstrates the use of the CryptFile Class.
'
'Note that binary access writes/reads a true stream: you can write and
'then read back in entirely different sized chunks.
'

Private Const BINARYFILE As String = "EncBinary.dat"
Private Const TEXTFILE As String = "EncText.dat"

Private CryptFile As New CryptFile

Private Sub cmdDecryptBinary_Click()
    Dim lngBytesLeft As Long
    Dim lngPartSize As Long
    Dim bytPart() As Byte
    
    txtContent.Text = ""
    txtContent.SelStart = 0
    With CryptFile
        .OpenFile BINARYFILE, txtPassphrase.Text, cfaReadBinary
        lngBytesLeft = .LOF
        If lngBytesLeft > 20 Then
            'We'll break the content into ~ 7 parts (rounding down to
            'an even number of bytes because we're using Unicode and
            'thus we need 2 bytes per character) for demonstration.
            'We could read the file in one "part" if we chose to.
            lngPartSize = ((lngBytesLeft \ 7&) \ 2&) * 2&
        Else
            'And for a very small case we DO read it in one part.
            lngPartSize = lngBytesLeft
        End If
        ReDim bytPart(lngPartSize - 1)
        Do While lngBytesLeft > 0
            If lngBytesLeft < lngPartSize Then ReDim bytPart(lngBytesLeft - 1)
            .ReadBytes bytPart
            txtContent.SelText = bytPart
            lngBytesLeft = lngBytesLeft - lngPartSize
        Loop
        .CloseFile
    End With
    txtContent.SelStart = 0
End Sub

Private Sub cmdDecryptText_Click()
    txtContent.Text = ""
    txtContent.SelStart = 0
    With CryptFile
        .OpenFile TEXTFILE, txtPassphrase.Text, cfaReadText
        Do Until .EOF
            txtContent.SelText = .ReadLine() & vbNewLine
        Loop
        .CloseFile
    End With
    txtContent.SelStart = 0
End Sub

Private Sub cmdEncryptBinary_Click()
    Dim strFull As String
    Dim lngCharsLeft As Long
    Dim lngPartSize As Long
    Dim lngNext As Long
    Dim bytPart() As Byte
    
    strFull = txtContent.Text
    lngCharsLeft = Len(strFull)
    If lngCharsLeft > 10 Then
        'We'll break the content into ~ 4 parts for demonstration.
        lngPartSize = lngCharsLeft \ 4&
    Else
        lngPartSize = lngCharsLeft
    End If
    lngNext = 1
    With CryptFile
        .OpenFile BINARYFILE, txtPassphrase.Text, cfaWriteBinary
        Do Until lngNext > Len(strFull)
            bytPart = Mid$(strFull, lngNext, lngPartSize)
            lngNext = lngNext + lngPartSize
            .WriteBytes bytPart
        Loop
        .CloseFile
    End With
    txtContent.Text = ""
    cmdDecryptBinary.Enabled = True
End Sub

Private Sub cmdEncryptText_Click()
    Dim strLines() As String
    Dim I As Long
    Dim LastI As Long
    
    strLines = Split(txtContent.Text, vbNewLine)
    With CryptFile
        .OpenFile TEXTFILE, txtPassphrase.Text, cfaWriteText
        'If "last line" is empty (txtContent.Text ends at a new line) skip it:
        LastI = UBound(strLines) - IIf(Len(strLines(UBound(strLines))) > 0, 0, 1)
        For I = 0 To LastI
            .WriteLine strLines(I)
        Next
        .CloseFile
    End With
    txtContent.Text = ""
    cmdDecryptText.Enabled = True
End Sub

Private Sub Form_Load()
    On Error Resume Next
    GetAttr BINARYFILE
    cmdDecryptBinary.Enabled = Err.Number = 0
    Err.Clear
    GetAttr TEXTFILE
    cmdDecryptText.Enabled = Err.Number = 0
End Sub
